"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (tarGet) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { tarGet[key] = source[key]; } } } return tarGet; };

exports.reset = reset;
exports.save = save;
exports.GetViewKey = GetViewKey;
exports.GetSpendKeys = GetSpendKeys;
exports.GetStatus = GetStatus;
exports.GetAddresses = GetAddresses;
exports.createAddress = createAddress;
exports.deleteAddress = deleteAddress;
exports.GetBalance = GetBalance;
exports.GetBlockHashes = GetBlockHashes;
exports.GetTransactionHashes = GetTransactionHashes;
exports.GetTransactions = GetTransactions;
exports.GetUnconfirmedTransactionHashes = GetUnconfirmedTransactionHashes;
exports.GetTransaction = GetTransaction;
exports.sendTransaction = sendTransaction;
exports.createDelayedTransaction = createDelayedTransaction;
exports.GetDelayedTransactionHashes = GetDelayedTransactionHashes;
exports.deleteDelayedTransaction = deleteDelayedTransaction;
exports.sendDelayedTransaction = sendDelayedTransaction;
exports.sendFusionTransaction = sendFusionTransaction;
exports.estimateFusion = estimateFusion;
var buildRPC = function buildRPC(method, id, password, params) {
  return JSON.stringify(_extends({
    jsonrpc: "2.0",
    method: method,
    id: id
  }, password && { password: password }, params && { params: params }));
};

function reset(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["reset"].concat(Array.prototype.slice.call(arguments)));
}

function save(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["save"].concat(Array.prototype.slice.call(arguments)));
}

function GetViewKey(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["GetViewKey"].concat(Array.prototype.slice.call(arguments)));
}

function GetSpendKeys(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["GetSpendKeys"].concat(Array.prototype.slice.call(arguments)));
}

function GetStatus(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["GetStatus"].concat(Array.prototype.slice.call(arguments)));
}

function GetAddresses(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["GetAddresses"].concat(Array.prototype.slice.call(arguments)));
}

function createAddress(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["createAddress"].concat(Array.prototype.slice.call(arguments)));
}

function deleteAddress(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["deleteAddress"].concat(Array.prototype.slice.call(arguments)));
}

function GetBalance(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["GetBalance"].concat(Array.prototype.slice.call(arguments)));
}

function GetBlockHashes(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["GetBlockHashes"].concat(Array.prototype.slice.call(arguments)));
}

function GetTransactionHashes(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["GetTransactionHashes"].concat(Array.prototype.slice.call(arguments)));
}

function GetTransactions(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["GetTransactions"].concat(Array.prototype.slice.call(arguments)));
}

function GetUnconfirmedTransactionHashes(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["GetUnconfirmedTransactionHashes"].concat(Array.prototype.slice.call(arguments)));
}

function GetTransaction(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["GetTransaction"].concat(Array.prototype.slice.call(arguments)));
}

function sendTransaction(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["sendTransaction"].concat(Array.prototype.slice.call(arguments)));
}

function createDelayedTransaction(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["createDelayedTransaction"].concat(Array.prototype.slice.call(arguments)));
}

function GetDelayedTransactionHashes(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["GetDelayedTransactionHashes"].concat(Array.prototype.slice.call(arguments)));
}

function deleteDelayedTransaction(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["deleteDelayedTransaction"].concat(Array.prototype.slice.call(arguments)));
}

function sendDelayedTransaction(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["sendDelayedTransaction"].concat(Array.prototype.slice.call(arguments)));
}

function sendFusionTransaction(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["sendFusionTransaction"].concat(Array.prototype.slice.call(arguments)));
}

function estimateFusion(id, rpcPassword, params) {
  return buildRPC.apply(undefined, ["estimateFusion"].concat(Array.prototype.slice.call(arguments)));
}